# std::array::data

From cppreference.com
< cpp‎ | container‎ | array

T* data(); |  | (until C++17)
constexpr T* data(); |  | (since C++17)
const T* data() const; |  | (until C++17)
constexpr const T* data() const; |  | (since C++17)

Returns pointer to the underlying array serving as element storage. The pointer is such that range `[data(); data() + size())` is always a valid range, even if the container is empty (`data()` is not dereferenceable in that case).

### Parameters

(none)

### Return value

Pointer to the underlying element storage. For non-empty containers, returns &front()

### Complexity

Constant.

### Exceptions

`noexcept` specification:
noexcept

### See also

front | access the first element (public member function)
back | access the last element (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/container/array/data&oldid=50435"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template